
import java.util.Random;


public class CandyGame {

	//array contenente le caramelle possedute da ogni bambino
	private int[] bambini;
	
	//inizializzo la struttura del gioco
	public CandyGame() {
		bambini = new int[]{ 3 , 3 , 3 };

	}
	
	//metodo necessario ad effetturare il movimento
	//del bambino di posto child
	//N.B. vengono sfruttati i moduli per effettuare
	//i movimenti all'interno dell'array in modo sicuro
	public boolean move( int child ) {
		//prima di chiamare il metodo controllo che
		//il gioco non sia finito e l'input sia corretto
		if(finito() || child<0 || child >= 3)
			return false;	
		//punto 1
		if( bambini[child] >= 1 && bambini[child] != 2 ) {
			bambini[child] --;
			return true;
		}
		//punto 2.1
		if(bambini[(child+2)%3]>0) {
			bambini[(child+2)%3]--;
			bambini[child]++;
			return true;
		}
		//punto 2.2
		if(bambini[(child+1)%3]>0) {
			bambini[(child+1)%3]--;
			bambini[(child+2)%3]++;
			return true;
		}
		return false;
	}
	
	//metodo che segnala la fine del gioco
	public boolean finito() {
		return	bambini[0] == 0 &&
				bambini[1] == 0 &&
				bambini[2] == 0 ;
	}
	
	public void game() {
		Random r = new Random();
		while( !finito() ) {
			move(r.nextInt(3));
			//System.out.println(toString());
		}
	}
	/*
	@Override
	public String toString() {
		String s = "";
		for (int i = 0; i < bambini.length; i++) {
			s += bambini[i] +" ";
		}
		return s;
	}
	//*
	public static void main(String[] args) {
		CandyGame c = new CandyGame();
		c.game();
	}
	*/
	
}
