import nz.ac.waikato.modeljunit.Action;
import nz.ac.waikato.modeljunit.FsmModel;

public class CandyGameFSM implements FsmModel {

	CandyGame sut;

	public CandyGameFSM() {
		sut = new CandyGame();
	}

	@Action
	public void move1() {
		sut.move(0);
	}

	public boolean move1Guard() {
		return canMove(1);
	}

	@Action
	public void move2() {
		sut.move(1);
	}

	public boolean move2Guard() {
		return canMove(2);
	}

	@Action
	public void move3() {
		sut.move(2);
	}

	public boolean move3Guard() {
		return canMove(3);
	}

	@Override
	public Object getState() {
		return sut.toString();
	}

	@Override
	public void reset(boolean arg0) {
		sut = new CandyGame();
	}

	// return true if the child can do something (change global state)
	private boolean canMove(int child) {
		// it can eat
		if (sut.getCaramelle(child) > 0 || sut.getCaramelle(child) != 2)
			return true;
		// it can steal
		if (sut.getCaramelle((child + 2) % 3) > 0)
			return true;
		// it can pass
		if (sut.getCaramelle((child - 1) % 3) > 0)
			return true;
		return false;
	}

}
