import static org.junit.Assert.*;

import org.junit.Test;

public class CandyGameTestSoluzione1 {

	@Test
	public void testScenario() {
		// costruisco lo scenario a mano 
		// potrebbe esserci scenario pi corto
		// da aggiungere tutti gli assert sulle move
		CandyGame cg = new CandyGame();
		assertEquals(cg.getCaramelle(0), 3);
		assertEquals(cg.getCaramelle(1), 3);
		assertEquals(cg.getCaramelle(2), 3);
		// alternativamente posso usare questa:
		assertArrayEquals(new int[]{3,3,3}, cg.getCaramelle());
		assertTrue(cg.move(0));
		cg.move(1);
		cg.move(2);
		assertArrayEquals(new int[]{2,2,2}, cg.getCaramelle());
		assertFalse(cg.finito());
		// faccio muovere uno in modo che rubi una caramella 
		cg.move(1);
		// il bimbo 1 ha rubato una caramella
		assertArrayEquals(new int[]{1,3,2}, cg.getCaramelle());
		// 0 mangia la sua ultima 
		cg.move(0);
		assertArrayEquals(new int[]{0,3,2}, cg.getCaramelle());
		// 1 mangia
		cg.move(1);
		assertArrayEquals(new int[]{0,2,2}, cg.getCaramelle());
		// 2 ruba ma tiene
		cg.move(2);
		assertArrayEquals(new int[]{0,1,3}, cg.getCaramelle());
		// 0 ruba a 2
		cg.move(0);
		assertArrayEquals(new int[]{1,1,2}, cg.getCaramelle());
		// 1 mangia
		cg.move(1);
		assertArrayEquals(new int[]{1,0,2}, cg.getCaramelle());
		// 0 mangia
		cg.move(0);
		assertArrayEquals(new int[]{0,0,2}, cg.getCaramelle());
		// 0 ruba
		cg.move(0);
		assertArrayEquals(new int[]{1,0,1}, cg.getCaramelle());
		// 0 mangia
		cg.move(0);
		assertArrayEquals(new int[]{0,0,1}, cg.getCaramelle());
		// 2 mangia
		cg.move(2);
		assertArrayEquals(new int[]{0,0,0}, cg.getCaramelle());
		assertTrue(cg.finito());
	}
}
