import static org.junit.Assert.*;

import org.junit.Test;

//viene applicato il test di copertura MCDC sulla decisione:
//(finito() || child<0 || child >= 3)
//presente all'inizio della funzione move


public class MCDCTest {

	@Test
	public void test() {
		CandyGame c = new CandyGame();
		assertNotNull(c);
		//test1
		//finito()=false	childe<0=false		child>=3=false
		//result=false(quindi l'istruzione dovrebbe tornare true continuando la sua esecuzione)
		assertTrue(c.move(2));//test1
		//test2
		//finito()=false	childe<0=true		child>=3=false
		//result=true(quindi l'istruzione dovrebbe tornare false)
		assertFalse(c.move(-2));//test1
		//test3
		//finito()=false	childe<0=false		child>=3=true
		//result=true(quindi l'istruzione dovrebbe tornare false)
		assertFalse(c.move(22));
		//test4
		//finito()=true		childe<0=false		child>=3=false
		//result=true(quindi l'istruzione dovrebbe tornare false)
		//devo far concludere il gioco perch si verifichi,
		//dunque riutilizzo lo schema di CandyGameTest
		c = new CandyGame();
		assertNotNull(c);
		for( int i = 0 ; i < 3 ; i ++ )
			assertTrue(c.move(i));
		for( int i = 0 ; i < 3 ; i ++ ) {
			assertTrue(c.move(i));
			assertTrue(c.move(i));
			assertTrue(c.move((i+2)%3));
		}
		assertTrue(c.finito());
		//ecco il risultato sperato
		assertFalse(c.move(2));
	}

}
