import static org.junit.Assert.*;

import org.junit.Test;

//Copertura delle istruzioni

//coincide con Branch Coverage e di conseguenza Decision Coverage

public class StatementCoverageTest {

	@Test
	public void test() {
		
		//partendo dal caso di test precedente copriamo le istruzioni rimanenti
		CandyGame c = new CandyGame();
		assertNotNull(c);
		for( int i = 0 ; i < 3 ; i ++ )
			assertTrue(c.move(i));
		for( int i = 0 ; i < 3 ; i ++ ) {
			assertTrue(c.move(i));
			assertTrue(c.move(i));
			assertTrue(c.move((i+2)%3));
		}
		//questa istruzione serve per eseguire il primo "return false" 
		assertFalse(c.move(-1));
		assertTrue(c.finito());
		
		c = new CandyGame();
		assertNotNull(c);
		assertTrue(c.move(0));
		assertTrue(c.move(1));
		assertTrue(c.move(1));
		assertTrue(c.move(0));
		assertTrue(c.move(1));
		assertTrue(c.move(1));
		//questo pezzo serve per far ritornare false alla funzione move
		//con l'ultimo "return false"
		//ci avviene nella condizione in cui due bambini han finito
		//le caramelle e muoviamo il terzo che ne ha 2
		assertTrue(c.move(0));
		assertTrue(c.move(0));
		assertTrue(c.move(0));
		assertTrue(c.move(2));
		assertFalse(c.move(1));
		c.game();
		assertTrue(c.finito());
		
		
	}

}
